#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <common.h>
#include <stdlib.h>
#include "part.h"
#include <fat.h>

block_dev_desc_t user_dev_desc;

ulong fs_read(int device, lbaint_t blknr, ulong blkcnt, void *buffer)
{	
	int offset = blknr * 512;
	int len;

	debug("fs_read: dev %d start %qX, blocks %lX, buffer %lX\n",
		device, (long long unsigned int)blknr, blkcnt, (ulong) buffer);

	lseek(device, offset, SEEK_SET);
	len = read(device, (void *)buffer, blkcnt * 512);

	return (len / 512);
}

void init_user_desc(block_dev_desc_t *user_dev)
{

	user_dev->type = DEV_TYPE_UNKNOWN;
	user_dev->if_type = IF_TYPE_IDE;
	user_dev->dev = 0;
	user_dev->part_type = PART_TYPE_UNKNOWN;
	user_dev->blksz = 512;
	user_dev->lba = 0;
	user_dev->block_read = fs_read;
}

int main(int argc, char **argv) 
{
	int fd;
	if (argc < 2) {
		printf("<process_name> file\n");
		exit(-1);
	}
	
	init_user_desc(&user_dev_desc);
	fd = open(argv[1], O_RDWR);
	if (fd < 0) {
		printf("unable to open file\n");
		exit(-1);
	}

	user_dev_desc.dev = fd;
	fat_register_device(&user_dev_desc, 0);
	file_fat_detectfs();
	file_fat_ls("/prova");
	
	return 0;
}

